/*
 * $Id: ConverterOption.java,v 1.3 2003/04/06 01:50:50 ymakise Exp $
 */

/*
 * Copyright (c) 2002-2003, MAKISE Yoshitaro
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * 3. Neither the name of the iModoki nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package jp.sourceforge.imodoki.converter;

import java.io.File;

/**
 * СϤ줿ץΥƥʡ
 */
public class ConverterOption {
    /* verbose ٥ */
    public static final int QUIET   = 0;
    public static final int TERSE   = 1;
    public static final int VERBOSE = 2;
    public static final int DEBUG   = 3;

    private boolean m_debugBuild;
    private File m_outputDir;
    private File m_workDir;
    private boolean m_keepWorkDir;
    private int m_verbosity;

    public ConverterOption() {
    }

    public void setDebugBuild(boolean flag) {
        m_debugBuild = flag;
    }

    public boolean isDebugBuild() {
        return m_debugBuild;
    }

    public void setOutputDir(File dir) {
        m_outputDir = dir.getAbsoluteFile();
    }

    public File getOutputDir() {
        return m_outputDir;
    }

    public void setWorkDir(File dir) {
        m_workDir = dir;
    }

    public File getWorkDir() {
        return m_workDir;
    }

    public void setKeepWorkDir(boolean flag) {
        m_keepWorkDir = flag;
    }

    public boolean isKeepWorkDir() {
        return m_keepWorkDir;
    }

    public void setVerbosity(int verbosity) {
        m_verbosity = verbosity;
    }

    public int getVerbosity() {
        return m_verbosity;
    }
}
